#!/usr/bin/awk -f

function strip_quotes(var) {
	gsub(/^[\"']/, "", var);
	gsub(/[\"']$/, "", var);
	return var;
}

BEGIN {
	RS="config"
	printf("{\n");
	PREV_TYPE="";
}

$1 == "package" {
	next
}

$1 != "" {
	TAG_TYPE=strip_quotes($1);
	if (PREV_TYPE != TAG_TYPE) {
		PREV_TYPE=TAG_TYPE;
		printf("\t%s\"%s\": {\n\t\t", CLOSE_TYPE, TAG_TYPE);
		CLOSE_TAG="";
	}
	TAG_NAME=TAG_TYPE COUNT[TAG_TYPE];
	COUNT[TAG_TYPE]++;
	i=2;
	if ($2 != "option" && $2 != "list") {
		TAG_NAME=strip_quotes($2);
		i=3;
	}
	printf("%s\"%s\": {\n\t\t\t", CLOSE_TAG, TAG_NAME);
	CLOSE_TAG=""
	for (; i < NF; i++) {
		TAG=$i
		if ($i == "option") {
			OPT=strip_quotes($(i+1));
			VAL=strip_quotes($(i+2));
			for (j = i+2; j < NF; j++) {
				if (($(j+1) == "option") || ($(j+1) == "list"))
					break;
				VAL=VAL" "strip_quotes($(j+1));
			}
			printf("%s\"%s\": \"%s\"", CLOSE_TAG, OPT, VAL);
			CLOSE_TAG=",\n\t\t\t";
			i=j;
		} else if ($i == "list") {
			OPT=strip_quotes($(i+1));
			VAL=strip_quotes($(i+2));
			for (j = i+2; j < NF; j++) {
				if (($(j+1) == "option") || ($(j+1) == "list"))
					break;
				VAL=VAL" "strip_quotes($(j+1));
			}
			if (PREV_TAG != "list") {
				printf("%s\"%s\": [\n\t\t\t\t\"%s\"", CLOSE_TAG,
				       OPT, VAL);
				CLOSE_TAG="],\n\t\t\t"
			} else {
				printf(",\n\t\t\t\t\"%s\"", VAL);
			}
			i=j;
		}
		PREV_TAG=TAG;
	}
	if (PREV_TAG == "list")
		printf("\n\t\t\t]\n");
	else if (PREV_TAG == "option")
		printf("\n");
	CLOSE_TAG=",\n\t\t";
	CLOSE_TYPE="\n\t},\n\t";
	printf("\t\t}");
}

END {
	if (TAG_TYPE == "")
		printf("}\n");
	else
		printf("\n\t}\n}\n");
}
