#!/bin/sh
readonly BE_VERSION="1.4"
[ -z "${BE_TGT}" ] && BE_TGT=1
[ -z "${BE_ROOT}" ] && BE_ROOT="/usr/local/lib/webui"
[ -z "${BE_JSHN}" ] && BE_JSHN="/usr/share/libubox"
[ -z "${BE_BRXL}" ] && BE_BRXL="/barix/local"
[ -z "${BE_UCI}" ] && BE_UCI="${BE_BRXL}/config"
[ -z "${BE_UCI_DEF}" ] && BE_UCI_DEF="/barix/config/defaults"
[ -z "${BE_BCMK}" ] && BE_BCMK=0
[ -z "${BE_JLOG}" ] && BE_JLOG=1
[ -z "${BE_SLOG}" ] && BE_SLOG=0
readonly BRX_UCI="/lib/config/"
readonly AWK="${BE_ROOT}/awk"
readonly SH="${BE_ROOT}/sh"
readonly PASSWD="${BE_BRXL}/etc"
[ ${BE_BCMK} -eq 1 ] && . ${SH}/be_benchmark.sh
. ${BE_JSHN}/jshn.sh && INC_JSHN=1
. ${SH}/be_haserl.sh
. ${SH}/be_http.sh
. ${SH}/be_jlog.sh
. ${SH}/be_slog.sh
. ${SH}/be_ubus.sh
. ${SH}/be_utils.sh
_main_version_syslog() {
	local slog="${BE_SLOG}"
	BE_SLOG=1
	BE_SLOG=${slog}
	return 0
}
post_body="${1}"
S="be_main.sh"
ret=0
rq_mtd=""
cn_typ=""
fname=""
jlog_init "${S}"
slog_init "${S}"
_main_version_syslog
[ ${BE_SLOG} -eq 1 ] && haserl_env_syslog
haserl_var_get "REQUEST_METHOD" rq_mtd || ret=$?
if [ ${ret} -ne 0 ]; then
	jlog_err "${S}" "Error '${ret}' retrieving Request Method!"
	ubus_out "${ret}"
fi
if [ "${rq_mtd}" != "POST" ]; then
	jlog_err "${S}" "Request Method '${rq_mtd}' is not supported!"
	ubus_out "1"
fi
http_hdr_ct_get cn_typ || ret=$?
if [ ${ret} -ne 0 ]; then
	jlog_err "${S}" "Error '${ret}' getting Content-Type!"
	ubus_out "2"
fi
case "${cn_typ}" in
"application/json")
	do_ubus "${post_body}" || ret=$?
	if [ ${ret} -ne 0 ]; then
		jlog_err "${S}" "Error '${ret}' processing uBus request!"
		ubus_out "3"
	fi
	ret=3
	;;
"multipart/form-data")
	haserl_file_detect fname || ret=$?
	if [ ${ret} -ne 0 ]; then
		jlog_err "${S}" "Error '${ret}' detecting file!"
		ubus_out "4"
	fi
	haserl_file_import "${fname}" || ret=$?
	if [ ${ret} -ne 0 ]; then
		jlog_err "${S}" "Error '${ret}' importing file!"
		ubus_out "5"
	fi
	ret=5
	;;
*)
	jlog_err "${S}" "Content-Type '${cn_typ}' is not supported!"
	ret=6
	;;
esac
if [ ${ret} -ne 0 ]; then
	jlog_err "${S}" "Error '${ret}' processing '${cn_typ}' Content-Type!"
fi
ubus_out "${ret}"
slog_err "${S}" "Should not reach this point"
exit 0
