#!/bin/sh
readonly SLOG_TAG="webui-be"
_slog_write() {
	local func="$1" && shift
	local level="$1" && shift
	local str="$@"
	local prev_ifs
	utils_cmd_exists "logger" || return $?
	prev_ifs=$IFS
	IFS="
	"
	for line in ${str}; do
		logger -t "${SLOG_TAG}" -p "${level}" "${func}: ${line}"
	done
	IFS=${prev_ifs}
	return 0
}
slog_init() {
	[ ${BE_SLOG} -eq 0 ] && return 0
	name="${1}"
	_slog_write "${name}" "info" "Initialized Syslog Log Manager"
	return 0
}
slog_err() {
	[ ${BE_SLOG} -eq 0 ] && return 0
	local func="$1" && shift
	local str="$@"
	_slog_write "${func}" "err" "${str}"
	return 0
}
slog_inf() {
	[ ${BE_SLOG} -eq 0 ] && return 0
	local func="$1" && shift
	local str="$@"
	_slog_write "${func}" "info" "${str}"
	return 0
}
INC_SLOG=1
